/*
    This file is part of ben -- a task scheduler for distributed computations
    Copyright (C) 2012-2019  Laurent Poirrier

    ben is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "block.h"
#include "exec.h"
#include "man.h"

// ****************************************************************************
// 
// ****************************************************************************
#define DEBUG(...)	fprintf(stderr, __VA_ARGS__)
#define MAN_BIN		"man"

// ****************************************************************************
// 
// ****************************************************************************
static int man_exec(char *topic, char *data)
{
	char *argv[3];
	
	argv[0] = MAN_BIN;
	argv[1] = "/dev/stdin";
	argv[2] = NULL;
	
	return(exec_data(argv, topic, data));
}

// ****************************************************************************
// 
// ****************************************************************************
typedef struct man_entry_t {
	char *topic;
	char *data;
} man_entry;

static man_entry man_pages[] = {
  {
    "ben", 
#include "doc/ben.1.i"
  },
};

#define MAN_ENTRIES	(sizeof(man_pages) / sizeof(man_entry))

// ****************************************************************************
// 
// ****************************************************************************
int man(char *topic)
{
	size_t t;
	
	for (t = 0; t < MAN_ENTRIES; t++) {
		if (!strcmp(topic, man_pages[t].topic)) {
			return(man_exec(topic, man_pages[t].data));
		}
	}
	
	return(-1);
}
